
#define F_NUM neq[4]
#define NSTATES 6
#define NINPUTS 2

extern int get_flags();
static int Constraints;

void activate(message)
     char **message;
{
  int n,flags[1];

  *message = "boeing";
  
} 

void init(neq,params)
     int neq[];
     double *params;
{
  if ( params == 0 ) {
    neq[0] = NSTATES;
    neq[1] = NINPUTS;
    neq[11] = 6; /* 6 end-points constraints */
  }
}

void h(int *neq, double *t, double x[NSTATES], double u[NINPUTS], double xdot[NSTATES])
{
	int i, j;
	double A[6][6] = {{-0.089, -2.19,   0,     0.319, 0,     0},
	                  { 0.076, -0.217, -0.166, 0,     0,     0},
	                  {-0.602,  0.327, -0.975, 0,     0,     0},
	                  { 0,      0.15,   1,     0,     0,     0},
	                  { 0,      1,      0,     0,     0,     0},
	                  { 1,      0,      0,     0,     2.19,  0}};
	double B[6][2] = {{0,       0.0327},
                      {0.0264, -0.151},
	                  {0.227,   0.0636},
	                  {0,       0},
	                  {0,       0},
	                  {0,       0}};
    for(i = 0; i < NSTATES; i++){
		xdot[i] = 0;
		for(j = 0; j < NSTATES; j++){
			xdot[i] += A[i][j]*x[j];
		}
	}

	for(i = 0; i < NSTATES; i++){
		for(j = 0; j < NINPUTS; j++){
			xdot[i] += B[i][j]*u[j];
		}
	}
}

void Dh(int *neq, double *t, double x[NSTATES], double u[NINPUTS], double h_x[NSTATES][NSTATES], double h_u[NSTATES][NINPUTS])
{
}

double l(int neq[], double *t, double x[NINPUTS], double u[NINPUTS])
{
	double C[NSTATES] = {-0.089, 0, 0, 0, 0, 0};
	double D[NINPUTS] = {0, 0.0327};
	double ay = 0;
	double w_ay = 10;
	int i;
	for(i = 0; i < NSTATES; i++){
		ay += C[i]*x[i];
	}
	for(i = 0; i < NINPUTS; i++){
		ay += D[i]*u[i];
	}
	return  w_ay*w_ay*ay*ay + u[0]*u[0] + u[1]*u[1];
}


double Dl(int neq[], double *t, double x[NSTATES], double u[NINPUTS], double l_x[NSTATES], double l_u[NINPUTS])
{
	return 0.0;
}

double g(int neq[], double *t, double x0[NSTATES], double xf[NSTATES])
{
	switch (F_NUM) {
		case 1:
			return 0.0;
		case 2:
			return xf[0];
		case 3: 
			return xf[1];
		case 4:
			return xf[2];
		case 5:
			return xf[3];
		case 6:
			return xf[4];
		case 7:
			return xf[5] - 10;
	}
}

double Dg(int neq[], double *t, double x0[NSTATES], double xf[NSTATES], double J_x0[NSTATES], double J_xf[NSTATES])
{
    return 0.0;
}
