function [h_x,h_u] = sys_Dh(neq,t,x,u)

global sys_params

% h_x must be an n by n matrix.
% h_u must be an n by m matrix.

V = x(1);
R = x(2);
M = x(3);
tau = x(4);
M0 = 1.0;
MF = 0.6;
BETA = 500.0;
C_D = 0.05;
Arho0 = 12400.0;
C = 0.5;

h_x = zeros(4,4);
h_u = zeros(4,1);

rho  = exp(BETA*(1-R));
dDdv = rho*V*C_D*Arho0;
D    = V*dDdv/2;
dDdr = -BETA*D;

h_u(1,1) = tau/M;
h_u(3,1) = -tau/C;

h_x(1,1) = -tau*dDdv/M;
h_x(1,2) = tau*(-dDdr/M + 2/R^3);
h_x(1,3) = -tau*(u-D)/M^2;
h_x(1,4) = (u-D)/M - 1/R^2;
h_x(2,1) = tau;
h_x(2,4) = V;
h_x(3,4) = -u/C;
