function xdot = sys_h(neq,t,x,u)

global sys_params

% xdot must be a column vector with n rows.

V = x(1);
R = x(2);
M = x(3);
tau = x(4);
M0 = 1.0;
MF = 0.6;
BETA = 500.0;
C_D = 0.05;
Arho0 = 12400.0;
C = 0.5;

rho = exp(BETA*(1-R));
q = rho*V^2/2;
D = q*C_D*Arho0;

xdot = zeros(4,1);
xdot(1) = tau*( (u-D)/M - 1/R^2 );
xdot(2) = tau*V;                         
xdot(3) = -tau*u/C;                   
xdot(4) = 0.0;
