function neq = sys_init(params)

% Here is a list of the different system information paramters.
% neq = 1  : number of state variables.
% neq = 2  : number of inputs.
% neq = 3  : number of parameters.
% neq = 4  : reserved.
% neq = 5  : reserved.
% neq = 6  : number of objective functions.
% neq = 7  : number of nonlinear trajectory constraints.
% neq = 8  : number of linear trajectory constraints.
% neq = 9  : number of nonlinear endpoint inequality constraints.
% neq = 10 : number of linear endpoint inequality constraints.
% neq = 11 : number of nonlinear endpoint equality constraints.
% neq = 12 : number of linear endpoint equality constraints.
% neq = 13 : 0 => nonlinear, 1 => linear, 2 => LTI, 3 => LQR, 4 => LQR and LTI.

% The default value is 0 for all except neq = 6 which defaults to 1.

% if params == [] then setup neq.  Otherwise the system parameters are
% getting passed.

global Constraints

if isempty(params)

   % Each row of neq specifies a setting for one of the pieces of system
   % information.  For example, to set the number of parameters to 5
   % one row in neq should be [3 5].

   neq = [1 4 ; 2 1 ; 12 1];  % nstates = 4 ; ninputs = 1; 1 endpoint constr.
if (isempty(Constraints) ==0 )
   if Constraints == 1
      neq = [neq ; 3 1 ; 8 1]; % one system parameter (QMAX), 1 traj constr.
   end
end

else
   global sys_params QMAX
   sys_params = params;
   QMAX = params(1);
end
