%function [f0,x,gradL_u,gradL_x0]=a_lagrng_fnc(x0,u,t,ialg,action)
function [f0,x,gradL_u,gradL_x0]=a_lagfnc(x0,u,t,ialg,action)

% This function is called by pdmin.m, when using aug_lagrng.m.
% It constructs the values and gradient of the augmented Lagrangian.

global INFO PENALTIES MULTIPLIERS

if action <= 2,
  [f0,x]=simulate(1,x0,u,t,ialg,action);
else
  [f0,x,gradL_u,gradL_x0]=simulate(1,x0,u,t,ialg,action);
end
if isnan(f0), return; end

n_equality_constraints = sum(INFO(11:12));

for i = 1:n_equality_constraints
  C = simulate(2,i+1,1);
  if isnan(C), f0=NaN; return; end
  f0 = f0 - MULTIPLIERS(i)*C + PENALTIES(i)*C^2/2;
  if (action > 2),
    [du,dz] = simulate(2,i+1,2);
    gradL_u = gradL_u - MULTIPLIERS(i)*du + PENALTIES(i)*C*du;
    gradL_x0 = gradL_x0 - MULTIPLIERS(i)*dz + PENALTIES(i)*C*dz;
  end
end

