%function user_terminate = multiplier_update(f0,x,u,gradu,gradx0,I_i,free_x0)
function user_terminate = m_update(f0,x,u,gradu,gradx0,I_i,free_x0)

% Function to update the multipliers for an augmented lagrangian method
% with only equality constraints.  This function is called at the end
% of every inner loop iteration and solves a non-negative linear least
% squares problems to update the multipliers.

%
% Copyright (c) 1996 by Adam L. Schwartz
% All right reserved.  
%

global INFO MULTIPLIERS

%           ****---------- I M P O R T A N T ----------****
% Have to recompute the gradient of the objective function because the
% input arguments gradu and gradx0 are the gradients of the augemented
% Lagrangian.

[du,dx0]=simulate(2,1,2);
grad = [du(:) ; dx0(free_x0)];
grad = grad(I_i);

n = length(grad);
n_equality_constraints = sum(INFO(11:12));
A = zeros(n,n_equality_constraints);

for k = 1:n_equality_constraints
  [du,dx0] = simulate(2,1+k,2);
  gradg = [du(:) ; dx0(free_x0)];
  A(:,k)=gradg(I_i);
end

MULTIPLIERS = A\grad;

user_terminate = 1;

