% RIOTS_demo     This program demonstrates some of the capabilities of RIOTS.
%                You will not be able to use the demonstration version of
%                RIOTS to solve your own problems.  To purchase RIOTS_95 for
%                your PC, please contact the author (adams@eecs.berkeley.edu).
%
%                List of RIOTS demonstrations:
%                -----------------------------
%                1) System simulation, gradients, plotting.
%                2) Solving optimal control problems.
%                3) Solving a singular control problem.
%                4) Mesh redistribution.
%                5) Integration and control solution error estimation.
%                6) Warm starts.
%                7) Solving a multi-input control problem using numerical difference.
%
%                0) Quit.

% adapted from Carl de Boor's spdemos.m adaption of JNL's demos.m for Matlab.
%
% Copyright (c) 1996 by Adam L. Schwartz
% All right reserved.  
%

echo off
clear
Plotted = 0;
while 1
    demos= ['riotsdm1'
            'riotsdm2'
            'riotsdm3'
            'riotsdm4'
            'riotsdm5'
            'riotsdm6'
			'riotsdm7'];
    echo off
    clc
    help riotsdem
    n = input('Select a demo number: ');
    if ( (n > 0) & (n <= size(demos,1)) )
      demos = demos(n,:);
      eval(demos)
      Plotted = 1;
    elseif n == 0
      break
    end
end
echo off
if Plotted, 
  subplot(1,1,1)
  legend off
  set(gca,'xtickmode','auto')
end
clc
